git-rebase--interactive.shon commit Sync with maint (3f8acaa)
   1#!/bin/sh
   2#
   3# Copyright (c) 2006 Johannes E. Schindelin
   4
   5# SHORT DESCRIPTION
   6#
   7# This script makes it easy to fix up commits in the middle of a series,
   8# and rearrange commits.
   9#
  10# The original idea comes from Eric W. Biederman, in
  11# http://article.gmane.org/gmane.comp.version-control.git/22407
  12
  13. git-sh-setup
  14
  15# The file containing rebase commands, comments, and empty lines.
  16# This file is created by "git rebase -i" then edited by the user.  As
  17# the lines are processed, they are removed from the front of this
  18# file and written to the tail of $done.
  19todo="$state_dir"/git-rebase-todo
  20
  21# The rebase command lines that have already been processed.  A line
  22# is moved here when it is first handled, before any associated user
  23# actions.
  24done="$state_dir"/done
  25
  26# The commit message that is planned to be used for any changes that
  27# need to be committed following a user interaction.
  28msg="$state_dir"/message
  29
  30# The file into which is accumulated the suggested commit message for
  31# squash/fixup commands.  When the first of a series of squash/fixups
  32# is seen, the file is created and the commit message from the
  33# previous commit and from the first squash/fixup commit are written
  34# to it.  The commit message for each subsequent squash/fixup commit
  35# is appended to the file as it is processed.
  36#
  37# The first line of the file is of the form
  38#     # This is a combination of $count commits.
  39# where $count is the number of commits whose messages have been
  40# written to the file so far (including the initial "pick" commit).
  41# Each time that a commit message is processed, this line is read and
  42# updated.  It is deleted just before the combined commit is made.
  43squash_msg="$state_dir"/message-squash
  44
  45# If the current series of squash/fixups has not yet included a squash
  46# command, then this file exists and holds the commit message of the
  47# original "pick" commit.  (If the series ends without a "squash"
  48# command, then this can be used as the commit message of the combined
  49# commit without opening the editor.)
  50fixup_msg="$state_dir"/message-fixup
  51
  52# $rewritten is the name of a directory containing files for each
  53# commit that is reachable by at least one merge base of $head and
  54# $upstream. They are not necessarily rewritten, but their children
  55# might be.  This ensures that commits on merged, but otherwise
  56# unrelated side branches are left alone. (Think "X" in the man page's
  57# example.)
  58rewritten="$state_dir"/rewritten
  59
  60dropped="$state_dir"/dropped
  61
  62# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  63# GIT_AUTHOR_DATE that will be used for the commit that is currently
  64# being rebased.
  65author_script="$state_dir"/author-script
  66
  67# When an "edit" rebase command is being processed, the SHA1 of the
  68# commit to be edited is recorded in this file.  When "git rebase
  69# --continue" is executed, if there are any staged changes then they
  70# will be amended to the HEAD commit, but only provided the HEAD
  71# commit is still the commit to be edited.  When any other rebase
  72# command is processed, this file is deleted.
  73amend="$state_dir"/amend
  74
  75# For the post-rewrite hook, we make a list of rewritten commits and
  76# their new sha1s.  The rewritten-pending list keeps the sha1s of
  77# commits that have been processed, but not committed yet,
  78# e.g. because they are waiting for a 'squash' command.
  79rewritten_list="$state_dir"/rewritten-list
  80rewritten_pending="$state_dir"/rewritten-pending
  81
  82GIT_CHERRY_PICK_HELP="$resolvemsg"
  83export GIT_CHERRY_PICK_HELP
  84
  85warn () {
  86        printf '%s\n' "$*" >&2
  87}
  88
  89# Output the commit message for the specified commit.
  90commit_message () {
  91        git cat-file commit "$1" | sed "1,/^$/d"
  92}
  93
  94orig_reflog_action="$GIT_REFLOG_ACTION"
  95
  96comment_for_reflog () {
  97        case "$orig_reflog_action" in
  98        ''|rebase*)
  99                GIT_REFLOG_ACTION="rebase -i ($1)"
 100                export GIT_REFLOG_ACTION
 101                ;;
 102        esac
 103}
 104
 105last_count=
 106mark_action_done () {
 107        sed -e 1q < "$todo" >> "$done"
 108        sed -e 1d < "$todo" >> "$todo".new
 109        mv -f "$todo".new "$todo"
 110        new_count=$(sane_grep -c '^[^#]' < "$done")
 111        total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo")))
 112        if test "$last_count" != "$new_count"
 113        then
 114                last_count=$new_count
 115                printf "Rebasing (%d/%d)\r" $new_count $total
 116                test -z "$verbose" || echo
 117        fi
 118}
 119
 120make_patch () {
 121        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 122        case "$sha1_and_parents" in
 123        ?*' '?*' '?*)
 124                git diff --cc $sha1_and_parents
 125                ;;
 126        ?*' '?*)
 127                git diff-tree -p "$1^!"
 128                ;;
 129        *)
 130                echo "Root commit"
 131                ;;
 132        esac > "$state_dir"/patch
 133        test -f "$msg" ||
 134                commit_message "$1" > "$msg"
 135        test -f "$author_script" ||
 136                get_author_ident_from_commit "$1" > "$author_script"
 137}
 138
 139die_with_patch () {
 140        echo "$1" > "$state_dir"/stopped-sha
 141        make_patch "$1"
 142        git rerere
 143        die "$2"
 144}
 145
 146exit_with_patch () {
 147        echo "$1" > "$state_dir"/stopped-sha
 148        make_patch $1
 149        git rev-parse --verify HEAD > "$amend"
 150        warn "You can amend the commit now, with"
 151        warn
 152        warn "  git commit --amend"
 153        warn
 154        warn "Once you are satisfied with your changes, run"
 155        warn
 156        warn "  git rebase --continue"
 157        warn
 158        exit $2
 159}
 160
 161die_abort () {
 162        rm -rf "$state_dir"
 163        die "$1"
 164}
 165
 166has_action () {
 167        sane_grep '^[^#]' "$1" >/dev/null
 168}
 169
 170is_empty_commit() {
 171        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
 172                die "$1: not a commit that can be picked")
 173        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
 174                ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
 175        test "$tree" = "$ptree"
 176}
 177
 178# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 179# GIT_AUTHOR_DATE exported from the current environment.
 180do_with_author () {
 181        (
 182                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 183                "$@"
 184        )
 185}
 186
 187git_sequence_editor () {
 188        if test -z "$GIT_SEQUENCE_EDITOR"
 189        then
 190                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 191                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 192                then
 193                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 194                fi
 195        fi
 196
 197        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 198}
 199
 200pick_one () {
 201        ff=--ff
 202
 203        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 204        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 205        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 206
 207        if is_empty_commit "$sha1"
 208        then
 209                empty_args="--allow-empty"
 210        fi
 211
 212        test -d "$rewritten" &&
 213                pick_one_preserving_merges "$@" && return
 214        output git cherry-pick $empty_args $ff "$@"
 215}
 216
 217pick_one_preserving_merges () {
 218        fast_forward=t
 219        case "$1" in
 220        -n)
 221                fast_forward=f
 222                sha1=$2
 223                ;;
 224        *)
 225                sha1=$1
 226                ;;
 227        esac
 228        sha1=$(git rev-parse $sha1)
 229
 230        if test -f "$state_dir"/current-commit
 231        then
 232                if test "$fast_forward" = t
 233                then
 234                        while read current_commit
 235                        do
 236                                git rev-parse HEAD > "$rewritten"/$current_commit
 237                        done <"$state_dir"/current-commit
 238                        rm "$state_dir"/current-commit ||
 239                        die "Cannot write current commit's replacement sha1"
 240                fi
 241        fi
 242
 243        echo $sha1 >> "$state_dir"/current-commit
 244
 245        # rewrite parents; if none were rewritten, we can fast-forward.
 246        new_parents=
 247        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 248        if test "$pend" = " "
 249        then
 250                pend=" root"
 251        fi
 252        while [ "$pend" != "" ]
 253        do
 254                p=$(expr "$pend" : ' \([^ ]*\)')
 255                pend="${pend# $p}"
 256
 257                if test -f "$rewritten"/$p
 258                then
 259                        new_p=$(cat "$rewritten"/$p)
 260
 261                        # If the todo reordered commits, and our parent is marked for
 262                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 263                        # drop it on top of the current HEAD
 264                        if test -z "$new_p"
 265                        then
 266                                new_p=$(git rev-parse HEAD)
 267                        fi
 268
 269                        test $p != $new_p && fast_forward=f
 270                        case "$new_parents" in
 271                        *$new_p*)
 272                                ;; # do nothing; that parent is already there
 273                        *)
 274                                new_parents="$new_parents $new_p"
 275                                ;;
 276                        esac
 277                else
 278                        if test -f "$dropped"/$p
 279                        then
 280                                fast_forward=f
 281                                replacement="$(cat "$dropped"/$p)"
 282                                test -z "$replacement" && replacement=root
 283                                pend=" $replacement$pend"
 284                        else
 285                                new_parents="$new_parents $p"
 286                        fi
 287                fi
 288        done
 289        case $fast_forward in
 290        t)
 291                output warn "Fast-forward to $sha1"
 292                output git reset --hard $sha1 ||
 293                        die "Cannot fast-forward to $sha1"
 294                ;;
 295        f)
 296                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 297
 298                if [ "$1" != "-n" ]
 299                then
 300                        # detach HEAD to current parent
 301                        output git checkout $first_parent 2> /dev/null ||
 302                                die "Cannot move HEAD to $first_parent"
 303                fi
 304
 305                case "$new_parents" in
 306                ' '*' '*)
 307                        test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 308
 309                        # redo merge
 310                        author_script_content=$(get_author_ident_from_commit $sha1)
 311                        eval "$author_script_content"
 312                        msg_content="$(commit_message $sha1)"
 313                        # No point in merging the first parent, that's HEAD
 314                        new_parents=${new_parents# $first_parent}
 315                        if ! do_with_author output \
 316                                git merge --no-ff ${strategy:+-s $strategy} -m \
 317                                        "$msg_content" $new_parents
 318                        then
 319                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 320                                die_with_patch $sha1 "Error redoing merge $sha1"
 321                        fi
 322                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 323                        ;;
 324                *)
 325                        output git cherry-pick "$@" ||
 326                                die_with_patch $sha1 "Could not pick $sha1"
 327                        ;;
 328                esac
 329                ;;
 330        esac
 331}
 332
 333nth_string () {
 334        case "$1" in
 335        *1[0-9]|*[04-9]) echo "$1"th;;
 336        *1) echo "$1"st;;
 337        *2) echo "$1"nd;;
 338        *3) echo "$1"rd;;
 339        esac
 340}
 341
 342update_squash_messages () {
 343        if test -f "$squash_msg"; then
 344                mv "$squash_msg" "$squash_msg".bak || exit
 345                count=$(($(sed -n \
 346                        -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
 347                        -e "q" < "$squash_msg".bak)+1))
 348                {
 349                        echo "# This is a combination of $count commits."
 350                        sed -e 1d -e '2,/^./{
 351                                /^$/d
 352                        }' <"$squash_msg".bak
 353                } >"$squash_msg"
 354        else
 355                commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
 356                count=2
 357                {
 358                        echo "# This is a combination of 2 commits."
 359                        echo "# The first commit's message is:"
 360                        echo
 361                        cat "$fixup_msg"
 362                } >"$squash_msg"
 363        fi
 364        case $1 in
 365        squash)
 366                rm -f "$fixup_msg"
 367                echo
 368                echo "# This is the $(nth_string $count) commit message:"
 369                echo
 370                commit_message $2
 371                ;;
 372        fixup)
 373                echo
 374                echo "# The $(nth_string $count) commit message will be skipped:"
 375                echo
 376                commit_message $2 | sed -e 's/^/#       /'
 377                ;;
 378        esac >>"$squash_msg"
 379}
 380
 381peek_next_command () {
 382        sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo"
 383}
 384
 385# A squash/fixup has failed.  Prepare the long version of the squash
 386# commit message, then die_with_patch.  This code path requires the
 387# user to edit the combined commit message for all commits that have
 388# been squashed/fixedup so far.  So also erase the old squash
 389# messages, effectively causing the combined commit to be used as the
 390# new basis for any further squash/fixups.  Args: sha1 rest
 391die_failed_squash() {
 392        mv "$squash_msg" "$msg" || exit
 393        rm -f "$fixup_msg"
 394        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 395        warn
 396        warn "Could not apply $1... $2"
 397        die_with_patch $1 ""
 398}
 399
 400flush_rewritten_pending() {
 401        test -s "$rewritten_pending" || return
 402        newsha1="$(git rev-parse HEAD^0)"
 403        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 404        rm -f "$rewritten_pending"
 405}
 406
 407record_in_rewritten() {
 408        oldsha1="$(git rev-parse $1)"
 409        echo "$oldsha1" >> "$rewritten_pending"
 410
 411        case "$(peek_next_command)" in
 412        squash|s|fixup|f)
 413                ;;
 414        *)
 415                flush_rewritten_pending
 416                ;;
 417        esac
 418}
 419
 420do_next () {
 421        rm -f "$msg" "$author_script" "$amend" || exit
 422        read -r command sha1 rest < "$todo"
 423        case "$command" in
 424        '#'*|''|noop)
 425                mark_action_done
 426                ;;
 427        pick|p)
 428                comment_for_reflog pick
 429
 430                mark_action_done
 431                pick_one $sha1 ||
 432                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 433                record_in_rewritten $sha1
 434                ;;
 435        reword|r)
 436                comment_for_reflog reword
 437
 438                mark_action_done
 439                pick_one $sha1 ||
 440                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 441                git commit --amend --no-post-rewrite || {
 442                        warn "Could not amend commit after successfully picking $sha1... $rest"
 443                        warn "This is most likely due to an empty commit message, or the pre-commit hook"
 444                        warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
 445                        warn "you are able to reword the commit."
 446                        exit_with_patch $sha1 1
 447                }
 448                record_in_rewritten $sha1
 449                ;;
 450        edit|e)
 451                comment_for_reflog edit
 452
 453                mark_action_done
 454                pick_one $sha1 ||
 455                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 456                warn "Stopped at $sha1... $rest"
 457                exit_with_patch $sha1 0
 458                ;;
 459        squash|s|fixup|f)
 460                case "$command" in
 461                squash|s)
 462                        squash_style=squash
 463                        ;;
 464                fixup|f)
 465                        squash_style=fixup
 466                        ;;
 467                esac
 468                comment_for_reflog $squash_style
 469
 470                test -f "$done" && has_action "$done" ||
 471                        die "Cannot '$squash_style' without a previous commit"
 472
 473                mark_action_done
 474                update_squash_messages $squash_style $sha1
 475                author_script_content=$(get_author_ident_from_commit HEAD)
 476                echo "$author_script_content" > "$author_script"
 477                eval "$author_script_content"
 478                output git reset --soft HEAD^
 479                pick_one -n $sha1 || die_failed_squash $sha1 "$rest"
 480                case "$(peek_next_command)" in
 481                squash|s|fixup|f)
 482                        # This is an intermediate commit; its message will only be
 483                        # used in case of trouble.  So use the long version:
 484                        do_with_author output git commit --no-verify -F "$squash_msg" ||
 485                                die_failed_squash $sha1 "$rest"
 486                        ;;
 487                *)
 488                        # This is the final command of this squash/fixup group
 489                        if test -f "$fixup_msg"
 490                        then
 491                                do_with_author git commit --no-verify -F "$fixup_msg" ||
 492                                        die_failed_squash $sha1 "$rest"
 493                        else
 494                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 495                                rm -f "$GIT_DIR"/MERGE_MSG
 496                                do_with_author git commit --no-verify -e ||
 497                                        die_failed_squash $sha1 "$rest"
 498                        fi
 499                        rm -f "$squash_msg" "$fixup_msg"
 500                        ;;
 501                esac
 502                record_in_rewritten $sha1
 503                ;;
 504        x|"exec")
 505                read -r command rest < "$todo"
 506                mark_action_done
 507                printf 'Executing: %s\n' "$rest"
 508                # "exec" command doesn't take a sha1 in the todo-list.
 509                # => can't just use $sha1 here.
 510                git rev-parse --verify HEAD > "$state_dir"/stopped-sha
 511                ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
 512                status=$?
 513                # Run in subshell because require_clean_work_tree can die.
 514                dirty=f
 515                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 516                if test "$status" -ne 0
 517                then
 518                        warn "Execution failed: $rest"
 519                        test "$dirty" = f ||
 520                        warn "and made changes to the index and/or the working tree"
 521
 522                        warn "You can fix the problem, and then run"
 523                        warn
 524                        warn "  git rebase --continue"
 525                        warn
 526                        exit "$status"
 527                elif test "$dirty" = t
 528                then
 529                        warn "Execution succeeded: $rest"
 530                        warn "but left changes to the index and/or the working tree"
 531                        warn "Commit or stash your changes, and then run"
 532                        warn
 533                        warn "  git rebase --continue"
 534                        warn
 535                        exit 1
 536                fi
 537                ;;
 538        *)
 539                warn "Unknown command: $command $sha1 $rest"
 540                if git rev-parse --verify -q "$sha1" >/dev/null
 541                then
 542                        die_with_patch $sha1 "Please fix this in the file $todo."
 543                else
 544                        die "Please fix this in the file $todo."
 545                fi
 546                ;;
 547        esac
 548        test -s "$todo" && return
 549
 550        comment_for_reflog finish &&
 551        shortonto=$(git rev-parse --short $onto) &&
 552        newhead=$(git rev-parse HEAD) &&
 553        case $head_name in
 554        refs/*)
 555                message="$GIT_REFLOG_ACTION: $head_name onto $shortonto" &&
 556                git update-ref -m "$message" $head_name $newhead $orig_head &&
 557                git symbolic-ref \
 558                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 559                  HEAD $head_name
 560                ;;
 561        esac && {
 562                test ! -f "$state_dir"/verbose ||
 563                        git diff-tree --stat $orig_head..HEAD
 564        } &&
 565        {
 566                test -s "$rewritten_list" &&
 567                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 568                true # we don't care if this copying failed
 569        } &&
 570        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 571                test -s "$rewritten_list"; then
 572                "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
 573                true # we don't care if this hook failed
 574        fi &&
 575        rm -rf "$state_dir" &&
 576        git gc --auto &&
 577        warn "Successfully rebased and updated $head_name."
 578
 579        exit
 580}
 581
 582do_rest () {
 583        while :
 584        do
 585                do_next
 586        done
 587}
 588
 589# skip picking commits whose parents are unchanged
 590skip_unnecessary_picks () {
 591        fd=3
 592        while read -r command rest
 593        do
 594                # fd=3 means we skip the command
 595                case "$fd,$command" in
 596                3,pick|3,p)
 597                        # pick a commit whose parent is current $onto -> skip
 598                        sha1=${rest%% *}
 599                        case "$(git rev-parse --verify --quiet "$sha1"^)" in
 600                        "$onto"*)
 601                                onto=$sha1
 602                                ;;
 603                        *)
 604                                fd=1
 605                                ;;
 606                        esac
 607                        ;;
 608                3,#*|3,)
 609                        # copy comments
 610                        ;;
 611                *)
 612                        fd=1
 613                        ;;
 614                esac
 615                printf '%s\n' "$command${rest:+ }$rest" >&$fd
 616        done <"$todo" >"$todo.new" 3>>"$done" &&
 617        mv -f "$todo".new "$todo" &&
 618        case "$(peek_next_command)" in
 619        squash|s|fixup|f)
 620                record_in_rewritten "$onto"
 621                ;;
 622        esac ||
 623        die "Could not skip unnecessary pick commands"
 624}
 625
 626# Rearrange the todo list that has both "pick sha1 msg" and
 627# "pick sha1 fixup!/squash! msg" appears in it so that the latter
 628# comes immediately after the former, and change "pick" to
 629# "fixup"/"squash".
 630rearrange_squash () {
 631        # extract fixup!/squash! lines and resolve any referenced sha1's
 632        while read -r pick sha1 message
 633        do
 634                case "$message" in
 635                "squash! "*|"fixup! "*)
 636                        action="${message%%!*}"
 637                        rest="${message#*! }"
 638                        echo "$sha1 $action $rest"
 639                        # if it's a single word, try to resolve to a full sha1 and
 640                        # emit a second copy. This allows us to match on both message
 641                        # and on sha1 prefix
 642                        if test "${rest#* }" = "$rest"; then
 643                                fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
 644                                if test -n "$fullsha"; then
 645                                        # prefix the action to uniquely identify this line as
 646                                        # intended for full sha1 match
 647                                        echo "$sha1 +$action $fullsha"
 648                                fi
 649                        fi
 650                esac
 651        done >"$1.sq" <"$1"
 652        test -s "$1.sq" || return
 653
 654        used=
 655        while read -r pick sha1 message
 656        do
 657                case " $used" in
 658                *" $sha1 "*) continue ;;
 659                esac
 660                printf '%s\n' "$pick $sha1 $message"
 661                used="$used$sha1 "
 662                while read -r squash action msg_content
 663                do
 664                        case " $used" in
 665                        *" $squash "*) continue ;;
 666                        esac
 667                        emit=0
 668                        case "$action" in
 669                        +*)
 670                                action="${action#+}"
 671                                # full sha1 prefix test
 672                                case "$msg_content" in "$sha1"*) emit=1;; esac ;;
 673                        *)
 674                                # message prefix test
 675                                case "$message" in "$msg_content"*) emit=1;; esac ;;
 676                        esac
 677                        if test $emit = 1; then
 678                                printf '%s\n' "$action $squash $action! $msg_content"
 679                                used="$used$squash "
 680                        fi
 681                done <"$1.sq"
 682        done >"$1.rearranged" <"$1"
 683        cat "$1.rearranged" >"$1"
 684        rm -f "$1.sq" "$1.rearranged"
 685}
 686
 687case "$action" in
 688continue)
 689        # do we have anything to commit?
 690        if git diff-index --cached --quiet HEAD --
 691        then
 692                : Nothing to commit -- skip this
 693        else
 694                if ! test -f "$author_script"
 695                then
 696                        die "You have staged changes in your working tree. If these changes are meant to be
 697squashed into the previous commit, run:
 698
 699  git commit --amend
 700
 701If they are meant to go into a new commit, run:
 702
 703  git commit
 704
 705In both case, once you're done, continue with:
 706
 707  git rebase --continue
 708"
 709                fi
 710                . "$author_script" ||
 711                        die "Error trying to find the author identity to amend commit"
 712                current_head=
 713                if test -f "$amend"
 714                then
 715                        current_head=$(git rev-parse --verify HEAD)
 716                        test "$current_head" = $(cat "$amend") ||
 717                        die "\
 718You have uncommitted changes in your working tree. Please, commit them
 719first and then run 'git rebase --continue' again."
 720                        git reset --soft HEAD^ ||
 721                        die "Cannot rewind the HEAD"
 722                fi
 723                do_with_author git commit --no-verify -F "$msg" -e || {
 724                        test -n "$current_head" && git reset --soft $current_head
 725                        die "Could not commit staged changes."
 726                }
 727        fi
 728
 729        record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
 730
 731        require_clean_work_tree "rebase"
 732        do_rest
 733        ;;
 734skip)
 735        git rerere clear
 736
 737        do_rest
 738        ;;
 739esac
 740
 741git var GIT_COMMITTER_IDENT >/dev/null ||
 742        die "You need to set your committer info first"
 743
 744comment_for_reflog start
 745
 746if test ! -z "$switch_to"
 747then
 748        output git checkout "$switch_to" -- ||
 749                die "Could not checkout $switch_to"
 750fi
 751
 752orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
 753mkdir "$state_dir" || die "Could not create temporary $state_dir"
 754
 755: > "$state_dir"/interactive || die "Could not mark as interactive"
 756write_basic_state
 757if test t = "$preserve_merges"
 758then
 759        if test -z "$rebase_root"
 760        then
 761                mkdir "$rewritten" &&
 762                for c in $(git merge-base --all $orig_head $upstream)
 763                do
 764                        echo $onto > "$rewritten"/$c ||
 765                                die "Could not init rewritten commits"
 766                done
 767        else
 768                mkdir "$rewritten" &&
 769                echo $onto > "$rewritten"/root ||
 770                        die "Could not init rewritten commits"
 771        fi
 772        # No cherry-pick because our first pass is to determine
 773        # parents to rewrite and skipping dropped commits would
 774        # prematurely end our probe
 775        merges_option=
 776else
 777        merges_option="--no-merges --cherry-pick"
 778fi
 779
 780shorthead=$(git rev-parse --short $orig_head)
 781shortonto=$(git rev-parse --short $onto)
 782if test -z "$rebase_root"
 783        # this is now equivalent to ! -z "$upstream"
 784then
 785        shortupstream=$(git rev-parse --short $upstream)
 786        revisions=$upstream...$orig_head
 787        shortrevisions=$shortupstream..$shorthead
 788else
 789        revisions=$onto...$orig_head
 790        shortrevisions=$shorthead
 791fi
 792git rev-list $merges_option --pretty=oneline --abbrev-commit \
 793        --abbrev=7 --reverse --left-right --topo-order \
 794        $revisions | \
 795        sed -n "s/^>//p" |
 796while read -r shortsha1 rest
 797do
 798
 799        if test -z "$keep_empty" && is_empty_commit $shortsha1
 800        then
 801                comment_out="# "
 802        else
 803                comment_out=
 804        fi
 805
 806        if test t != "$preserve_merges"
 807        then
 808                printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
 809        else
 810                sha1=$(git rev-parse $shortsha1)
 811                if test -z "$rebase_root"
 812                then
 813                        preserve=t
 814                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 815                        do
 816                                if test -f "$rewritten"/$p
 817                                then
 818                                        preserve=f
 819                                fi
 820                        done
 821                else
 822                        preserve=f
 823                fi
 824                if test f = "$preserve"
 825                then
 826                        touch "$rewritten"/$sha1
 827                        printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
 828                fi
 829        fi
 830done
 831
 832# Watch for commits that been dropped by --cherry-pick
 833if test t = "$preserve_merges"
 834then
 835        mkdir "$dropped"
 836        # Save all non-cherry-picked changes
 837        git rev-list $revisions --left-right --cherry-pick | \
 838                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
 839        # Now all commits and note which ones are missing in
 840        # not-cherry-picks and hence being dropped
 841        git rev-list $revisions |
 842        while read rev
 843        do
 844                if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
 845                then
 846                        # Use -f2 because if rev-list is telling us this commit is
 847                        # not worthwhile, we don't want to track its multiple heads,
 848                        # just the history of its first-parent for others that will
 849                        # be rebasing on top of it
 850                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
 851                        short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
 852                        sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
 853                        rm "$rewritten"/$rev
 854                fi
 855        done
 856fi
 857
 858test -s "$todo" || echo noop >> "$todo"
 859test -n "$autosquash" && rearrange_squash "$todo"
 860cat >> "$todo" << EOF
 861
 862# Rebase $shortrevisions onto $shortonto
 863#
 864# Commands:
 865#  p, pick = use commit
 866#  r, reword = use commit, but edit the commit message
 867#  e, edit = use commit, but stop for amending
 868#  s, squash = use commit, but meld into previous commit
 869#  f, fixup = like "squash", but discard this commit's log message
 870#  x, exec = run command (the rest of the line) using shell
 871#
 872# These lines can be re-ordered; they are executed from top to bottom.
 873#
 874# If you remove a line here THAT COMMIT WILL BE LOST.
 875# However, if you remove everything, the rebase will be aborted.
 876#
 877EOF
 878
 879if test -z "$keep_empty"
 880then
 881        echo "# Note that empty commits are commented out" >>"$todo"
 882fi
 883
 884
 885has_action "$todo" ||
 886        die_abort "Nothing to do"
 887
 888cp "$todo" "$todo".backup
 889git_sequence_editor "$todo" ||
 890        die_abort "Could not execute editor"
 891
 892has_action "$todo" ||
 893        die_abort "Nothing to do"
 894
 895test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
 896
 897output git checkout $onto || die_abort "could not detach HEAD"
 898git update-ref ORIG_HEAD $orig_head
 899do_rest